#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "max_m": 2 * 10**5,
    "a": 2,
    "b": 1,
    "c": 2,
    "max_w": 10**4,
    "special": 0,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    max_m = int(cmdlinearg("max_m"))
    k = n // 2 - random.randint(0, 1)
    a = int(cmdlinearg("a"))
    b = int(cmdlinearg("b"))
    c = int(cmdlinearg("c"))
    max_w = int(cmdlinearg("max_w"))
    special = int(cmdlinearg("special"))

    d = n - 2 - a - b - c
    assert d >= 0

    edges = []

    if special == 1:
        edges.append((0, n-1))

    for i in range(1, c+1):
        edges.append((0, i))
        edges.append((n-1, i))
    
    for i in range(c+1, a+c+1):
        edges.append((0, i))

    for i in range(a+c+1, a+b+c+1):
        edges.append((n-1, i))

    W = [0] * n
    W[0] = max_w
    W[n-1] = max_w

    for i in range(1, c+1):
        W[i] = max_w
    

    for _ in range(2*max_m):
        i = random.randrange(c+1, a+c+1)
        j = random.randrange(a+c+1, a+b+c+1)
        if W[i] != 0 and W[j] != 0:
            continue
        extra = min(d, 1)
        if len(edges) + extra + 1 > max_m:
            break

        if W[i] != 0:
            W[j] = max_w - W[i] - extra
        elif W[j] != 0:
            W[i] = max_w - W[j] - extra
        else:
            W[i] = random.randint(1, max_w-1-extra)
            W[j] = max_w - W[i] - extra
        
        if extra == 1:
            edges.append((i, n-d-1))
            edges.append((n-d-1, j))
            W[n-d-1] = 1
            d -= 1
        else:
            edges.append((i, j))

    for i in range(n):
        if W[i] == 0:
            W[i] = random.randint(1, max_w)
    

    permutation = list(range(1, n-1))
    random.shuffle(permutation)
    permutation = [0] + permutation + [n-1]
    W2 = [0] * n
    for i in range(n):
        W2[permutation[i]] = W[i]

    print(n,len(edges),k)
    random.shuffle(edges)
    print(*W2)
    for e in edges:
        print(permutation[e[0]]+1, permutation[e[1]]+1)

    
if __name__ == "__main__":
    main()