#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "same": 7,
    "distinct": -1,
    "max_d":10**9,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    same = int(cmdlinearg("same"))
    d = int(cmdlinearg("distinct"))
    max_d = int(cmdlinearg("max_d"))

    if d == -1:
        d = n
    d = min(d, max_d+1)
    vals = random.sample(range(0, max_d+1), d)
    nums = [vals[0]] * same + [vals[random.randrange(1, d)] for _ in range(n-same)]
    print(n)
    random.shuffle(nums)
    print(*nums)
    random.shuffle(nums)
    print(*nums)

    
    
if __name__ == "__main__":
    main()