#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "distinct": -1,
    "max_d":10**9,
    "swaps": -1,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    d = int(cmdlinearg("distinct"))
    max_d = int(cmdlinearg("max_d"))
    swaps = int(cmdlinearg("swaps"))

    if d == -1:
        d = n
    d = min(d, max_d+1)
    vals = random.sample(range(0, max_d+1), d)
    print(n)
    nums = [vals[random.randrange(0, d)] for _ in range(n)]

    print(*nums)
    if swaps != -1:
        for _ in range(swaps):
            i = random.randrange(0, n)
            j = random.randrange(0, n)
            nums[i], nums[j] = nums[j], nums[i]
    else:
        random.shuffle(nums)
    print(*nums)

    
    
if __name__ == "__main__":
    main()