#!/bin/bash
USE_SCORING=0
. ../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution nils.cpp

compile gen_random.py
compile gen_repeating.py
compile gen_mostly_same.py

MAXN=1000000
MAXW=1000000000

sample 1
sample 2

tc small-01 gen_random n=2 max_d=10
tc small-02 gen_random n=5 max_d=10
tc small-03 gen_random n=10 max_d=10
tc small-04 gen_random n=100 max_d=100
tc small-05 gen_random n=100 max_d=10
tc small-06 gen_random n=100 max_d=2
tc medium-07 gen_random n=10000 max_d=10000
tc medium-08 gen_random n=10000 max_d=100
tc medium-09 gen_random n=10000 max_d=2
tc large-10 gen_random n=$MAXN
tc large-11 gen_random n=$MAXN max_d=$MAXN
tc large-12 gen_random n=$MAXN distinct=100
tc large-13 gen_random n=$MAXN max_d=$MAXN
tc large-14 gen_random n=$MAXN max_d=10000
tc large-15 gen_random n=$MAXN max_d=100
tc large-16 gen_random n=$MAXN max_d=10
tc large-17 gen_random n=$MAXN max_d=5
tc large-18 gen_random n=$MAXN max_d=2
tc large-19 gen_random n=$MAXN max_d=0
tc_manual ../manual_tests/case-01.in
tc_manual ../manual_tests/case-02.in
tc same-22 gen_random n=$MAXN max_d=10000 swaps=0
tc swaps-23 gen_random n=100000 max_d=100 swaps=1
tc swaps-24 gen_random n=100000 max_d=100 swaps=10
tc swaps-25 gen_random n=$MAXN max_d=10000 swaps=100
tc repeating-26 gen_repeating n=20 max_d=10 part_size=10
tc repeating-27 gen_repeating n=20 max_d=20 part_size=3
tc repeating-28 gen_repeating n=100000 max_d=10 part_size=50000
tc repeating-29 gen_repeating n=100000 max_d=100 part_size=21000
tc repeating-30 gen_repeating n=100000 max_d=1000 part_size=300
tc repeating-31 gen_repeating n=$MAXN max_d=100000 part_size=500000
tc_manual ../manual_tests/per1.in
tc_manual ../manual_tests/per2.in
tc_manual ../manual_tests/per3.in
tc_manual ../manual_tests/per4.in
tc repeating-36 gen_repeating n=$MAXN part_size=7777
tc repeating-37 gen_repeating n=$MAXN part_size=100000
tc repeating-38 gen_repeating n=$MAXN part_size=400000
tc same-39 gen_mostly_same n=$MAXN same=$(($MAXN - 10)) distinct=5
tc same-40 gen_mostly_same n=$MAXN same=$(($MAXN - 10000)) distinct=5
tc same-41 gen_mostly_same n=$MAXN same=$(($MAXN - 100))
