import sys
import math


def lcm(a, b):
    return abs(a * b) // math.gcd(a, b)


def solve(fname):
    with open(fname, "r") as fin:
        k = int(fin.readline())
        pairs = [tuple(map(int, fin.readline().split(" "))) for _ in range(k)]
        return sorted([y + lcm(c1, c2) for (y, c1, c2) in pairs])[0]


def main(fnames):
    for fname in fnames:
        assert fname.endswith(".in")
        solution = solve(fname)
        with open(fname[:-3] + ".ans", "w") as fout:
            fout.write(str(solution) + "\n")


if __name__ == "__main__":
    from sys import argv

    if len(argv) < 2:
        exit("Usage: solver *.in")
    main(argv[1:])
